<?php

class YrmFiltersPro {
	public function __construct() {
		$this->init();
	}

	private function init() {
		add_filter('ycdReadMoreFinalContent', array($this, 'addCustomContent'), 3, 3);
		add_filter('yrmDefaultOptions', array($this, 'yrmDefaultOptions'),1, 3);
		add_filter('yrmContentStyles', array($this, 'yrmContentStyles'),1, 3);
		add_filter('upgrader_pre_download', array($this, 'shortenEddFilename'), 10, 4);
		add_filter('yrmSaveOptions', array($this, 'saveOptions'), 10, 2);
	}

	public function yrmDefaultOptions($options)
	{
		$options['yrm-button-bottom-border-width'] = '1px';
		$options['yrm-button-bottom-border-style'] = 'solid';

		return $options;
	}

	public function saveOptions($options, $obj)
	{
		$options['yrm-popup-theme'] = $obj->expmSanitizeData('yrm-popup-theme');
		$options['yrm-popup-width'] = $obj->expmSanitizeData('yrm-popup-width');
		$options['yrm-popup-height'] = $obj->expmSanitizeData('yrm-popup-height');
		$options['yrm-popup-max-width'] = $obj->expmSanitizeData('yrm-popup-max-width');
		$options['yrm-popup-max-height'] = $obj->expmSanitizeData('yrm-popup-max-height');
		$options['yrm-popup-initial-width'] = $obj->expmSanitizeData('yrm-popup-initial-width');
		$options['yrm-popup-initial-height'] = $obj->expmSanitizeData('yrm-popup-initial-height');
		$options['yrm-popup-esc-key'] = $obj->expmSanitizeData('yrm-popup-esc-key');
		$options['yrm-popup-close-button'] = $obj->expmSanitizeData('yrm-popup-close-button');
		$options['yrm-popup-overlay-click'] = $obj->expmSanitizeData('yrm-popup-overlay-click');
		$options['yrm-popup-overlay-color'] = $obj->expmSanitizeData('yrm-popup-overlay-color');
		$options['yrm-popup-content-color'] = $obj->expmSanitizeData('yrm-popup-content-color');
		$options['yrm-popup-content-padding'] = $obj->expmSanitizeData('yrm-popup-content-padding');
		$options['yrm-button-border-bottom'] = $obj->expmSanitizeData('yrm-button-border-bottom');
		$options['yrm-button-bottom-border-style'] = $obj->expmSanitizeData('yrm-button-bottom-border-style');
		$options['yrm-button-bottom-border-width'] = $obj->expmSanitizeData('yrm-button-bottom-border-width');
		$options['yrm-button-bottom-border-color'] = $obj->expmSanitizeData('yrm-button-bottom-border-color');

		return $options;
	}
	
	public function shortenEddFilename($return, $package)
	{
		if (strpos($package, YRM_STORE_URL) !== false) {
			add_filter('wp_unique_filename', array($this, 'shortenEddFilename'), 100, 2);
		}
		return $return;
	}

	public function addCustomContent($content, $args, $id) {
		if (!empty($args['hidden-content-font-size-enable'])) {
			$content .= '<style>';
				$fontSize = (int)$args['hidden-content-font-size'].'px';
				$content .= '.yrm-cntent-'.$id.' {';
				$content .= 'font-size: '.$fontSize.';';
				$content .= '}';
			$content .= '</style>';
		}
		return $content;
	}

	public function yrmContentStyles($styles, $obj, $id)
	{
		$important = '!important';

		if(is_admin()) {
			$important = '';
		}
		$type = $obj->getOptionValue('type');

		if($obj->getOptionValue('hidden-content-bg-image')) {
			$bgSize = $obj->getOptionValue('hidden-content-bg-img-size');
			$bgRepeat = $obj->getOptionValue('hidden-content-bg-repeat');
			$bgURL = $obj->getOptionValue('hidden-bg-image-url');

			$styles .= '<style id="bg-image-styles">';
			$styles .= '.yrm-content-'.$id.' {';
			$styles .= 'background-image: url('.$bgURL.');';
			$styles .= 'background-size: '.$bgSize.';';
			$styles .= 'background-repeat: '.$bgRepeat.';';
			$styles .= '}';
			$styles .= '</style>';
		}
		if ($obj->getOptionValue('yrm-hidden-content-line-height') == 'customLineHeight') {
			$styles .= '<style type="text/css">';
			$styles .= '.yrm-content-'.$id.' {';
			$styles .= 'line-height: '.$obj->getOptionValue('yrm-hidden-content-line-height-size').' '.$important;
			$styles .= '}';
			$styles .= '</style>';
		}

		$borderBottomAllowTypes = array('inline', 'inlinePopup', 'alink');
		$enabledBorderBottom = $obj->getOptionValue('yrm-button-border-bottom');

		if (in_array($type, $borderBottomAllowTypes) && !empty($enabledBorderBottom)) {
			$borderBottomWidth = $obj->getOptionValue('yrm-button-bottom-border-width');
			$borderBottomStyle = $obj->getOptionValue('yrm-button-bottom-border-style');
			$borderBottomColor = $obj->getOptionValue('yrm-button-bottom-border-color');

			$styles .= '<style type="text/css">';
			$styles .= '.yrm-button-text-'.$id.' {';
				$styles .= 'border-bottom: '.$borderBottomWidth.' '.$borderBottomStyle.' '.$borderBottomColor;
			$styles .= '}';
			$styles .= '</style>';
		}

		return $styles;
	}
}

new YrmFiltersPro();